package com.example.tdl.util;
import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.domain.vo.*;
import com.example.tdl.service.CircuitService;
//import com.example.tdl.service.InfluxDBService;
import com.example.tdl.service.TDLLogService;
import com.example.tdl.web.I18nController;
import com.google.gson.Gson;
import org.influxdb.dto.Query;
import org.influxdb.dto.QueryResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.influxdb.InfluxDBTemplate;
import retrofit2.http.POST;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class DataUtil {

    private static Logger logger = LoggerFactory.getLogger(DataUtil.class);

    private static  Gson gson = new Gson();

   private static CommFeedback fb = new CommFeedback();

    public  static  String   getData(String transportationNo, HttpServletRequest request,I18nController i18n,String companyNo,CircuitService circuitService,TDLLogService tdlLogService,InfluxDBTemplate influxDBTemplate,String database,String field,String event ){
        Long t1 = System.currentTimeMillis();
        logger.info(t1+"---------t1");
        ResultCircuitVo resultCircuitVo = circuitService.getByTransportationNo(transportationNo, companyNo);
        if (resultCircuitVo == null) {
            fb.setCode(0);
            fb.setMessage(i18n.getMessage(request, "noCircuit"));
            return gson.toJson(fb);
        }
        if (resultCircuitVo.getStartTime() == null || resultCircuitVo.getStartTime() == 0) {
            fb.setCode(0);
            fb.setMessage(i18n.getMessage(request, "notStarted"));
            return gson.toJson(fb);
        }
        Long startTime = resultCircuitVo.getStartTime() * 1000000l;
        TDLLogVo gatewayVo = tdlLogService.getByTransportationNo(transportationNo);
        if (gatewayVo == null) {
            fb.setCode(0);
            fb.setMessage(i18n.getMessage(request, "noCircuit"));
            return gson.toJson(fb);
        }
        String device = gatewayVo.getgType() + "_" + gatewayVo.getgSN();
        //获取tdl信息
        List<String> devList = tdlLogService.getTdlSN(transportationNo);
        if (devList.size() == 0) {
            fb.setCode(0);
            fb.setMessage(i18n.getMessage(request, "noCircuit"));
            return gson.toJson(fb);
        }
        Long t2 = System.currentTimeMillis();
        List<HistoryDataVo> historyDataVoList = new ArrayList<>();
        for (int i = 0; i < devList.size(); i++) {
            HistoryDataVo historyDataVo = new HistoryDataVo();
            String TDLSN = devList.get(i).replace("TDL-", "").trim();
            historyDataVo.setTDLSN(TDLSN);
            if("\"T\"".equals(field) || "\"h\"".equals(field)){
                ResultAlarmVo resultAlarmVo = tdlLogService.getByTdl(transportationNo, TDLSN);
                //根据tdl货物报警信息
                historyDataVo.setMax(resultAlarmVo.getTemMax().toString());
                historyDataVo.setMin(resultAlarmVo.getTemMin().toString());
            }
            List<HistoryData> historyData = new ArrayList<>();
            String sqls = "";
            if (resultCircuitVo.getEndTime() != null && resultCircuitVo.getEndTime() != 0) {
                sqls = "SELECT count("+field+") FROM \"tdl_policy\".\"" + device + "\" WHERE  \"event\" = '"+event+"' and   \"tdl\"='" + devList.get(i) + "'  and time>=" + startTime + " and time <=" + resultCircuitVo.getEndTime() * 1000000l;
            } else {
                sqls = "SELECT count("+field+") FROM \"tdl_policy\".\"" + device + "\" WHERE \"event\" = '"+event+"' and \"tdl\"='" + devList.get(i) + "'  and time>=" + startTime + " and time <=" + System.currentTimeMillis() * 1000000l;
            }
            QueryResult queryResults = influxDBTemplate.query(new Query(sqls, database));
            Integer count;
            if (queryResults.getResults().get(0).getSeries() != null) {
                count = Double.valueOf(queryResults.getResults().get(0).getSeries().get(0).getValues().get(0).get(1).toString()).intValue();
            } else {
                historyDataVo.setDataList(historyData);
                historyDataVoList.add(historyDataVo);
                continue;
            }
            logger.info(count+"------");
            String sql = "";
            if (count > 500) {

                if (resultCircuitVo.getEndTime() != null && resultCircuitVo.getEndTime() != 0) {
                   sql = getSQL( gatewayVo.getgSN(),field, device, devList.get(i),  event,startTime, resultCircuitVo.getEndTime() * 1000000l);
                } else {
                    sql = getSQL(gatewayVo.getgSN(), field, device, devList.get(i),event, startTime, t1 * 1000000l);
                }
                QueryResult queryResult = influxDBTemplate.query(new Query(sql, database,false));
                if (queryResult.getResults() != null) {
                    historyData = getHistoryDatas(queryResult, field);
                }
                historyDataVo.setDataList(historyData);
                historyDataVoList.add(historyDataVo);
            } else {
                if (resultCircuitVo.getEndTime() != null && resultCircuitVo.getEndTime() != 0) {
                    sql = "SELECT "+field+" FROM \"tdl_policy\".\"" + device + "\" where \"data_type\" = 'data' AND \"tdl\"='" + devList.get(i) + "'  and time >=" + startTime + "  and time<=" + resultCircuitVo.getEndTime() * 1000000l + " ORDER BY time ";
                } else {
                    sql = "SELECT "+field+" FROM \"tdl_policy\".\"" + device + "\" where \"data_type\" = 'data' AND \"tdl\"='" + devList.get(i) + "'  and time >=" + startTime + "  ORDER BY time";
                }
                QueryResult queryResult = influxDBTemplate.query(new Query(sql, database, true));
                if (queryResult.getResults().get(0).getSeries() != null) {
                    //解析数据
                    historyData = getHistoryData(queryResult, field);
                }
                historyDataVo.setDataList(historyData);
                historyDataVoList.add(historyDataVo);
            }
        }
        logger.info(System.currentTimeMillis()-t1+"_______");
        return  gson.toJson(historyDataVoList);
    }

    public static String getSQL(String  SN,String field, String device, String tdl,String event, Long startTime, Long endTime) {
        String sql = "";
        long times = (endTime - startTime) / 500;
        for (int i = 0; i < 500; i++) {
            Long maxTime = startTime + times;
            sql = sql + "Select " + field + " From \"tdl_policy\".\"" + device + "\" where " +
                    "  \"event\" = '"+event+"' " +
                    " AND \"tdl\"='" + tdl + "' " +
                    "and  time >= "+startTime +" and time <= " + maxTime + " order by time limit 1;";
                    startTime = maxTime;
        }
       sql = sql + "Select " + field + " From \"tdl_policy\".\"" + device + "\" where  " +
               "  \"event\" = '"+event+"' " +
               " AND \"tdl\"='" + tdl + "' " +
               "and  time >= "+startTime+"  and time <= " + endTime + " order by time desc limit 1;";
        return sql;
    }


    public static List<HistoryData> getHistoryData(QueryResult queryResult, String alias) {
        List<List<Object>> values = getValues(queryResult);
        List<HistoryData> historyDataList = new ArrayList<>();
        for (List<Object> value : values) {
            HistoryData historyData = new HistoryData();
            historyData.setTime(parseTime(value.get(0).toString()));
            if (alias.contains("a0")) {
                if (value.get(1) != null && Double.valueOf(value.get(1).toString()) > 0 && Double.valueOf(value.get(1).toString()) < 588897) {
                    historyData.setValue(value.get(1) == null ? "" : value.get(1).toString());
                } else {
                    continue;
                }
            } else {
                historyData.setValue(value.get(1) == null ? "" : value.get(1).toString());
            }
            historyDataList.add(historyData);
        }
        return historyDataList;
    }

    public static List<List<Object>> getValues(QueryResult queryResult) {
        List<List<Object>> values = new ArrayList<>();
        for (QueryResult.Result result : queryResult.getResults()) {
            if (result.getSeries() != null) {
                for (QueryResult.Series series : result.getSeries()) {
                    if (series != null) {
                        values = series.getValues();
                    }
                }
            }
        }
        return values;
    }

    public static String parseTime(String time) {
        String dateResult = null;
        try {
            dateResult = dateToStamp(time);
        } catch (ParseException e) {
            e.printStackTrace();
            fb.setCode(0);
            fb.setMessage("解析时间异常");
        }
        return dateResult;
    }

    public static String dateToStamp(String s) throws ParseException {
        Date date = null;
        if (s.length() != 20) {
            date = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'").parse(s);
        } else {
            date = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'").parse(s);
        }
        return String.valueOf(date.getTime());
    }

    public static List<HistoryData> getHistoryDatas(QueryResult queryResult, String alias) {
        String dateResult = null;
        List<List<Object>> value = new ArrayList<>();
        Long t0 = System.currentTimeMillis();
        logger.info(t0 +"-------t0");
        for (QueryResult.Result result : queryResult.getResults()) {
            if (result.getSeries() != null) {
                for (QueryResult.Series series : result.getSeries()) {
                    if (series != null) {
                        value.add(series.getValues().get(0));
                    } else {
                        continue;
                    }
                }
            } else {
                continue;
            }
        }
        Long tm = System.currentTimeMillis();
        logger.info(System.currentTimeMillis()-t0 +"-------tm");
        List<HistoryData> historyDataList = new ArrayList<>();
        for (int i = 0; i < value.size(); i++) {
            HistoryData historyData = new HistoryData();
            historyData.setTime(parseTime(value.get(i).get(0).toString()));
            historyData.setValue(value.get(i).get(1).toString());
            historyDataList.add(historyData);
        }
        logger.info(System.currentTimeMillis()-tm +"-------tn");
        return historyDataList;
    }




}
